"""Cell_contain_indexes_of_column_and_row

Revision ID: f95ceb87a711
Revises: ea493a3c3fe4
Create Date: 2021-09-09 13:08:17.571535

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = 'f95ceb87a711'
down_revision = 'ea493a3c3fe4'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        'board', sa.Column('size', sa.SmallInteger(), nullable=False)
    )
    op.create_check_constraint(
        'board_size_check',
        'board',
        'size BETWEEN 4 AND 29'
    )
    op.add_column(
        'cell', sa.Column('row_index', sa.SmallInteger(), nullable=False)
    )
    op.add_column(
        'cell', sa.Column('col_index', sa.SmallInteger(), nullable=False)
    )
    op.drop_constraint('cell_board_id_row_col_key', 'cell', type_='unique')
    op.create_unique_constraint(
        None, 'cell', ['board_id', 'row_index', 'col_index']
    )
    op.create_check_constraint(
        'cell_row_index_check',
        'cell',
        'row_index >= 0'
    )
    op.create_check_constraint(
        'cell_col_index_check',
        'cell',
        'col_index >= 0'
    )
    op.drop_column('cell', 'col')
    op.drop_column('cell', 'row')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        'cell',
        sa.Column(
            'row',
            postgresql.ENUM(
                'ONE', 'TWO', 'THREE', 'FOUR', 'FIVE',
                'SIX', 'SEVEN', 'EIGHT', 'NINE', 'TEN',
                name='boardrow'
            ),
            autoincrement=False,
            nullable=False
        )
    )
    op.add_column(
        'cell',
        sa.Column(
            'col',
            postgresql.ENUM(
                'FIRST', 'SECOND', 'THIRD', 'FOURTH', 'FIFTH',
                'SIXTH', 'SEVENTH', 'EIGHTH', 'NINTH', 'TENTH',
                name='boardcolumn'
            ),
            autoincrement=False,
            nullable=False
        )
    )
    op.drop_constraint(None, 'cell', type_='unique')
    op.create_unique_constraint(
        'cell_board_id_row_col_key', 'cell', ['board_id', 'row', 'col']
    )
    op.drop_column('cell', 'col_index')
    op.drop_column('cell', 'row_index')
    op.drop_column('board', 'size')
    # ### end Alembic commands ###
